;*******************************************************************************
;A]. PARAMETERS & ANSWERS
;*******************************************************************************
; 		*NO EDIT* needed in this file. 
;		Please have your answers for the Installation wizard, together with other 
;			settings in a 'babylon.ini' file next to this script. 
;			Then just run the script.
;		If your .ini file is named differently or is not in the same folder as this 
;			script, simply run the script with the .ini file's [path\]name 
;			as an argument.
;		It there is no ini file, the script will install 'Babylon6_setup_eng_eng.exe' 
;			with default values.

Dim $wait = 15		;Number of seconds the script should wait for windows to show-up 
					;and processes to close before returning an error or proceeding
					;you can increase it if errors occur on slow computers
;*******************************************************************************

;###############################################################################
; ############################ No More Edits Below ############################
;###############################################################################

;*******************************************************************************
;B]. EXECUTION: Main program
;*******************************************************************************

;-------------------------------------------------------------------------------
;B0- Variables Declaration & assignation

;Registry keys used by the script:
$WabKey = "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\Babylon.exe"
$BabKey = "HKCU\Software\Babylon\Babylon Client\UserInfo"
$BKO = $BabKey & "\Options"

;PARAMETERS .ini file
Dim $inifile = "babylon.ini"
If $CmdLine[0] Then $inifile = $CmdLine[1]
$inifile = _ScriptPath($inifile)
If Not FileExists($inifile) Then $inifile = @ScriptDir & "\" & "babylon.ini"

;VARIABLES
;please look in the .ini file for explanations
Dim $Babylon 		= 			IniRead($inifile, "Setup"	, "Babylon"		, "Babylon6_setup_eng_eng.exe")
Dim $AllowedTime 	= Execute(	IniRead($inifile, "Setup"	, "AllowedTime"	, ""))
	If Not IsNumber($AllowedTime) Then $AllowedTime = 5 * 60		; -> 5mn
Dim $Language 		= 			IniRead($inifile, "Setup"	, "Language"	, "")
Dim $Licence[2]
	$Licence[0] 	= 			IniRead($inifile, "Setup"	, "UserName"	, "")
	$Licence[1] 	= 			IniRead($inifile, "Setup"	, "Licence Code", "")
Dim $DestDir 		= 			IniRead($inifile, "Setup"	, "DestDir"		, "")
Dim $Button 		= Number(	IniRead($inifile, "Setup"	, "Button"		, 502))
Dim $desktopIcon 	= Number(	IniRead($inifile, "Setup"	, "desktopIcon"	, 0))
Dim $QLaunchIcon 	= Number(	IniRead($inifile, "Setup"	, "QLaunchIcon"	, 1))
Dim $LaunchNow 		= Number(	IniRead($inifile, "Setup"	, "LaunchNow"	, 0))
Dim $Spam 			= 			IniRead($inifile, "Setup"	, "spam"		, "")
Dim $Glossaries 	= IniReadSection(	$inifile, "Glossaries")
Dim $MoreGlossaries = 			IniRead($inifile, "Glossaries", "MoreGlossaries", "BGL_Glossaries")
Dim $DwldLicensed 	= Number(	IniRead($inifile, "Babylon"	, "DwldLicensed", 0))
Dim $DictUpdate 	= Number(	IniRead($inifile, "Babylon"	, "DictUpdate"	, 2))
Dim $HideTrans 		= Number(	IniRead($inifile, "Babylon"	, "HideTrans"	, 0))
Dim $AutoStart 		= Number(	IniRead($inifile, "Babylon"	, "AutoStart"	, 1))
Dim $SpeechEngine 	= Number(	IniRead($inifile, "Babylon"	, "SpeechEngine", 0))


;-------------------------------------------------------------------------------
;B1- Run Babylon Setup Wizard
$Babylon = _InstallBabylon($Babylon)											;first, the first!


If $Babylon Then																;Only if installation was successful
	;---------------------------------------------------------------------------
	;B2a- get Babylon.exe full path
	$Babylon = RegRead($WabKey, "")												;There we're sure to find the Babylon exe path
	If Not FileExists($Babylon) Then _
		_errorMsgExit("Unable to find Babylon executable:" & @LF & $Babylon)	;oh, oh!

	;---------------------------------------------------------------------------
	;B2b- 1st Run (shortly) of Babylon NOW so it won't bother us later (reg tweaks, glossary install, etc.)
	RegWrite($BKO, "ShowStartScreen", "REG_DWORD", 1) 							;Remove Splash Screen
	Run($Babylon)
		WinWait("Babylon", "", $wait)
		Sleep(1500)																;that should be enough time to write infos to the registry
	ProcessClose("Babylon.exe")

	;---------------------------------------------------------------------------
	;B2c- Registry tweaking
							 RegWrite($BKO, "ShowStartScreen" , "REG_DWORD", 1) ;Remove AGAIN Splash Screen
	If 2 >  $DictUpdate Then RegWrite($BKO, "AutoDictUpdate"  , "REG_DWORD", 0)
	If Not 	$DictUpdate Then RegWrite($BKO, "EnableDictUpdate", "REG_DWORD", 0)
	If 		$HideTrans	Then RegWrite($BKO, "HideTranslation" , "REG_DWORD", 1)
	If Not 	$AutoStart	Then RegWrite($BabKey, "NoAutoStart"  , "REG_DWORD", 1)

	;---------------------------------------------------------------------------
	;B2d- Speech Engine
	If $SpeechEngine Then
		If FileExists(@ScriptDir & "\SPCHAPI.EXE") Then _
			RunWait(@ScriptDir & "\SPCHAPI.EXE /Q:A /R:N")
		If FileExists(@ScriptDir & "\MSTTSS22L.EXE") Then _
			RunWait(@ScriptDir & "\MSTTSS22L.EXE /Q:A /R:N")
	EndIf

	;---------------------------------------------------------------------------
	;B3- Install The ordered list of glossaries (.BGL or .exe) 
	If IsArray($Glossaries) Then
		for $i = 1 to $Glossaries[0][0]
			If $Glossaries[$i][0] <> "MoreGlossaries" And $Glossaries[$i][1] Then _
				$return = _InstallGlossary ($Glossaries[$i][0])
			If $return Then MsgBox(0, "Babylon6 Glossary installation", $return, 15)
		Next
	EndIf

	;---------------------------------------------------------------------------
	;B4- Automatically install the glossaries(.BGL) located in the subfolder
	If $MoreGlossaries Then
		$search = FileFindFirstFile(@ScriptDir & "\" & $MoreGlossaries & "\*.BGL")  
		If $search <> -1 Then													;found!
			While 1
				$file = FileFindNextFile($search) 
				If @error Then ExitLoop											;Nothing left to install
				$return = _InstallGlossary ($file)
				If $return Then MsgBox(0, "Babylon6 Glossary Installation", $return, 15)
			WEnd
		EndIf
		FileClose($search)
	EndIf

	;---------------------------------------------------------------------------
	;B5- Install License files
	$search = FileFindFirstFile(@ScriptDir & "\*.bof")  
	If $search <> -1 Then 														;found!
		$BabDir = RegRead($WabKey, "Path")
		While 1
			$file = FileFindNextFile($search) 
			If @error Then ExitLoop												;Nothing left to install
			$return = _InstallLicenseFile($file)
			If $return Then MsgBox(0, "Babylon6 License Installation", $return, 15)
		WEnd
	EndIf
	FileClose($search)
	
	;---------------------------------------------------------------------------
	;B6- Closes the process so it can (optionaly) start again with HKLM/Run ... or RUN it if the user wants to!
	If Not $LaunchNow Then 
		ProcessClose("Babylon.exe")
	ElseIf Not ProcessExists("Babylon.exe") Then
		Run($Babylon)
	EndIf
EndIf

Exit
;*******************************************************************************


;###############################################################################
; ############################## Functions Below ##############################
;###############################################################################


;*******************************************************************************
;C0. Error Handling Function
;*******************************************************************************
Func _errorMsgExit($Message, $wizPID = 0)
	If $wizPID Then ProcessClose($wizPID)
	MsgBox(0, "Babylon6 Unattended Installation", $Message, 60)
	Exit
EndFunc
;*******************************************************************************


;*******************************************************************************
;C1. Babylon Program Installer
;*******************************************************************************
Func _InstallBabylon ($installer)
	Local $list				; List of open processes, and then of open windows
    Local $wizPID 			; Setup process ID 
    Local $handle 			; wizard window handle
    Local $success			; returned value
    Local $i, $begin		; counter and initial value of the timer


	;---------------------------------------------------------------------------
	;C1a. prepare the command & the environment, and RUN the Installer
	$installer = _ScriptPath($installer)
	IF Not FileExists($installer) Then _
		_errorMsgExit("Failed: unable to find Babylon Installer program :(")
	
	If Not ProcessWaitClose ("Setup32.exe", $AllowedTime) Then _				;We don't want another process with the same name to run at the same time
		_errorMsgExit("Failed: time out waiting for other Setup to finish :(")
    If Not Run($installer) Then _												;GO! (Run the winzip SFX, which will in turn run Setup32 when it'll have finished)
		_errorMsgExit("Failed: unable to run Babylon Installer program :(")

	If Not ProcessWait ("Setup32.exe", $AllowedTime) Then _						;ready! (if installing a big Babylon -like Fr or Jp- over network, it can take ome time)
		_errorMsgExit("Failed: time out when waiting for Setup process :(")
	$list = ProcessList("Setup32.exe")
	If @error Or $list[0][0] <> 1 Then _										;we should have one and only one such process running
		_errorMsgExit("Failed: unable to find Babylon Setup PID :(")
	$wizPID = $list[1][1]														;Get an ID

    Opt("WinTitleMatchMode", 4)
	If Not WinWait("Babylon Setup", "", $wait) Then _							;Time out -> False start
		_errorMsgExit("Failed: unable to find Babylon Setup window :(", $wizPID)
	

    Local $begin = TimerInit()													;Timer to prevent an infinite loop below

	;---------------------------------------------------------------------------
	;C1b. FILL in the wizard pages
    Do
		;First, get a handle on the wizard window (this bastard changes at every window)
		while ProcessExists($wizPID)											;The installation process is running
			$list = WinList("classname=#32770")									;Get a list of open windows...
			If IsArray($list) And $list[0][0] Then
				For $i = 1 to $list[0][0]										;...and loop on them
					if WinGetProcess($list[$i][1]) = $wizPID Then ExitLoop 2	;bingo!: That window has the same PID as our process
				Next
			EndIf
		WEnd
		If Not ProcessExists($wizPID) Then ExitLoop								;$wizPID *have to* exist
		$handle = $list[$i][1]
		
        Select		;Then, depending on the window (recognised from its controls)
			;PAGE 0
            Case ControlShow ($handle,"",750)
				If IsNumber($Language) Then ControlCommand($handle, "",750, _	;Select a specific language
											"SetCurrentSelection", $Language)
                ControlClick($handle,"", 403) 									;Next
			;PAGE 1
            Case ControlShow ($handle,"",730)
                If $Licence[0] And $Licence[1] Then
					ControlClick($handle,"", 740)								;Valid Licence
					ControlSetText($handle,"", 302, $Licence[0])					;UserName
					ControlSetText($handle,"", 303, $Licence[1])					;Licence Code
				Else
					ControlClick($handle,"", 730)								;Evaluation Licence
				EndIf
				ControlClick($handle,"", 403)									;Next
			;PAGE 2
            Case ControlShow ($handle,"", "RichEdit20A1")
                ControlClick($handle,"", 403)    								;Yes
			;PAGE 3
            Case ControlShow ($handle,"", 801)
                If $Button > 500 And $Button < 504 Then _
					ControlClick($handle,"", $Button) 							;Activation Mouse Button
				If $DestDir And DirCreate($DestDir) Then _
					ControlSetText($handle,"", 801, $DestDir)					;Destination directory
				ControlClick($handle,"", 403)									;Next
			;PAGE 4
			Case ControlShow ($handle,"", 701)
				Sleep(3000)
				If Not $desktopIcon Then ControlClick($handle,"", 701)			;Desktop icon
				If Not $QLaunchIcon Then ControlClick($handle,"", 702)			;QuickLaunch icon
				ControlClick($handle,"", 703)									;Don't Run babylon now! No, I said No!
				If Not $Spam Then 
					ControlClick($handle,"", 704)								;Button6
				Else
					ControlSetText($handle,"", 720, $Spam)						;email
				EndIf
				ControlClick($handle,"", 403)									;Finish
				$success = 1													;Only now we have succeeded
			;In the midst of nowhere
			Case Else
				Sleep(500)														;Let's wait a bit
        EndSelect
        
		If TimerDiff($begin) > ($AllowedTime * 1000) Then _						;now we waited too much!
			_errorMsgExit("Failed: time-out installing Babylon :(", $wizPID)
    Until Not ProcessExists($wizPID)											;Installer process is finished, we can return

    Return $success
EndFunc
;*******************************************************************************


;*******************************************************************************
;C2. Glossaries Installer
;*******************************************************************************
Func _InstallGlossary ($BGLglossary)
	Local $list				; List of open processes, and then of open windows
    Local $wizPID 			; Babylon process ID
    Local $handle 			; Babylon window handle
    Local $i, $begin		; counter and initial value of the timer
    Local $exeprocess 		; exe glossary process name

	ProcessClose("Babylon.exe")
	
	;---------------------------------------------------------------------------
	;Shape & check the command
	If Not StringInStr($BGLglossary, "\") And $MoreGlossaries Then _
		$BGLglossary = @ScriptDir & "\" & $MoreGlossaries & "\" & $BGLglossary
	$BGLglossary = _ScriptPath($BGLglossary)
	If Not FileExists($BGLglossary) Then _
		Return $BGLglossary & @LF & "Failed: unable to find the glossary :("

	If Not ProcessWaitClose("Babylon.exe", $wait) Then _						;The way has to be clear
		Return $BGLglossary & @LF & "Failed: unable to shut down Babylon :("
	
	;---------------------------------------------------------------------------
	;When ready, install depending on the file type, and take note of the PID
	If StringRight($BGLglossary,4) = ".exe" Then
		$exeprocess = StringMid($BGLglossary, _
									StringInStr ($BGLglossary, "\", 0, -1) + 1)
		Run($BGLglossary)														;it's an .exe so just run it
		If Not ProcessWaitClose ($exeprocess, $AllowedTime) Then 				;Let's give it time to decompress files to temp dir
			If ProcessExists("Setup32.exe") Then ProcessClose("Setup32.exe")	;Most probably the user asked to run a full babylon installer
			ProcessClose($exeprocess)
			Return $BGLglossary & @LF & _
					"Failed: time out preparing install :(" & @LF & _
					"Check that it is NOT a FULL Babylon6 installer"
        EndIf
		If Not ProcessWait ("Babylon.exe", $wait) Then _						;it should have open Babylon by now
            Return $BGLglossary & @LF & "Failed: time out waiting for Babylon"
		$list = ProcessList("Babylon.exe")
		If Not IsArray($list) Or $list[0][0] <> 1 Then _						;we should have one and only one Babylon process running
            Return $BGLglossary & @LF & "Failed: unable to find Babylon PID :("
		$wizPID = $list[1][1]													;Get an ID
	
	ElseIf StringRight($BGLglossary,4) = ".bgl" Then							;We have to have Babylon process the file
		$wizPID = Run('"' & $Babylon & '" "' & $BGLglossary & '"', "", @SW_HIDE)
	EndIf
	
	If Not $wizPID Then _
		Return $BGLglossary & @LF & "Failed: unable to install the glossary :("
    
	Local $begin = TimerInit()													;Timer to prevent an infinite loop below

	;---------------------------------------------------------------------------
	;Let's find if our glossary is being installed
	while ProcessExists($wizPID)
		$list = WinList()
		If $list[0][0]>0 Then
			For $i = 1 to $list[0][0]
				If WinGetProcess($list[$i][1]) = $wizPID And _
				ControlShow ($list[$i][1],"", "msctls_progress321") Then 
					$handle = $list[$i][1]										;that is the glossary installation window
					If WinWaitClose($handle, "", $AllowedTime) Then ExitLoop 2	;Wait for it to close
				EndIf
			Next
		EndIf
		If TimerDiff($begin) > ($AllowedTime * 1000) Then 						;It should have started by now
            ProcessClose($wizPID)
			Return $BGLglossary & @LF & "Failed: time-out occured :("
        EndIf
	WEnd
	
EndFunc
;*****************************************************************************


;*******************************************************************************
;C3. License Files Installer
;*******************************************************************************
Func _InstallLicenseFile($file)
	;---------------------------------------------------------------------------
	;Prepare the ingredients
	ProcessClose("Babylon.exe")

	If Not ProcessWaitClose("Babylon.exe", $wait) Then _						;We need babylon fully closed before proceeding
		Return $file & @LF & "Failed: unable to shut down Babylon :("
	
	filecopy(@ScriptDir & "\" & $file, $BabDir & "\" & $file, 1)
	
	;---------------------------------------------------------------------------
	;Feed Babylon and see if it complains
	Run($Babylon)
	Opt("WinTitleMatchMode", 3)
	WinWait("Babylon", "", $wait)												;Doesn't Babylon find the matching dictionary?
	If ControlShow("Babylon","", 201) And ControlShow("Babylon","", 202) And _
			ControlShow("Babylon","", 203) Then
		If $DwldLicensed Then ControlClick("Babylon","", 203)					;Download the dictionary
		ControlClick("Babylon", "", 1)											;OK
		
		Opt("WinTitleMatchMode", 1)
		WinWait("Babylon", "", $wait)											;If connection to the server is not possible
		If ControlShow("Babylon","", 31587648) And _							;image -> ControlID:	31587648 -> ClassNameNN:	ATL:005E48201
			ControlShow("Babylon","", 31587592) And _							;texte -> ControlID:	31587592 -> ClassNameNN:	ATL:005E47D01
			ControlShow("Babylon","", 331) Then ControlClick("Babylon", "", 331);OK
	EndIf
EndFunc
;*******************************************************************************


;*******************************************************************************
;C4. if a path is relative to the script, make it a full path
;*******************************************************************************
Func _ScriptPath($filename)
	If Not StringInStr($filename, "\") Then _
		$filename = @ScriptDir & "\" & $filename
	If StringLeft($filename, 2) = ".\" Then _
		$filename = @ScriptDir & StringMid($filename, 2)
	Return $filename
EndFunc
;*****************************************************************************

